# Class VulkanCommandBufferCreateInfo

java.lang.Object
com.io7m.jcoronado.api.VulkanCommandBufferCreateInfo

All Implemented Interfaces:
  `VulkanCommandBufferCreateInfoType`

public final class VulkanCommandBufferCreateInfo extends Object implements VulkanCommandBufferCreateInfoType
Structure specifying parameters of a newly created command buffer.

See Also:
  - "VkCommandBufferAllocateInfo"

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static final class`
  `VulkanCommandBufferCreateInfo.Builder`
  Builds instances of type `VulkanCommandBufferCreateInfo`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static VulkanCommandBufferCreateInfo.Builder`
  `builder()`
  Creates a builder for `VulkanCommandBufferCreateInfo`.
  `static VulkanCommandBufferCreateInfo`
  `copyOf(VulkanCommandBufferCreateInfoType instance)`
  Creates an immutable copy of a `VulkanCommandBufferCreateInfoType` value.
  `int`
  `count()`
  `boolean`
  `equals(Object another)`
  This instance is equal to all instances of `VulkanCommandBufferCreateInfo` that have equal attribute values.
  `int`
  `hashCode()`
  Computes a hash code from attributes: `pool`, `level`, `count`.
  `VulkanCommandBufferLevel`
  `level()`
  `VulkanCommandPoolType`
  `pool()`
  `String`
  `toString()`
  Prints the immutable value `VulkanCommandBufferCreateInfo` with attribute values.
  `final VulkanCommandBufferCreateInfo`
  `withCount(int value)`
  Copy the current immutable object by setting a value for the `count` attribute.
  `final VulkanCommandBufferCreateInfo`
  `withLevel(VulkanCommandBufferLevel value)`
  Copy the current immutable object by setting a value for the `level` attribute.
  `final VulkanCommandBufferCreateInfo`
  `withPool(VulkanCommandPoolType value)`
  Copy the current immutable object by setting a value for the `pool` attribute.

  ### Methods inherited from class Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Method Details

  - ### pool

    public VulkanCommandPoolType pool()
    Specified by:
      `pool` in interface `VulkanCommandBufferCreateInfoType`
    Returns:
      The command pool

  - ### level

    public VulkanCommandBufferLevel level()
    Specified by:
      `level` in interface `VulkanCommandBufferCreateInfoType`
    Returns:
      The command buffer level

  - ### count

    public int count()
    Specified by:
      `count` in interface `VulkanCommandBufferCreateInfoType`
    Returns:
      The number of command buffers to allocate from the pool.

  - ### withPool

    public final VulkanCommandBufferCreateInfo withPool(VulkanCommandPoolType value)
    Copy the current immutable object by setting a value for the `pool` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for pool
    Returns:
      A modified copy or the `this` object

  - ### withLevel

    public final VulkanCommandBufferCreateInfo withLevel(VulkanCommandBufferLevel value)
    Copy the current immutable object by setting a value for the `level` attribute. A value equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for level
    Returns:
      A modified copy or the `this` object

  - ### withCount

    public final VulkanCommandBufferCreateInfo withCount(int value)
    Copy the current immutable object by setting a value for the `count` attribute. A value equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for count
    Returns:
      A modified copy or the `this` object

  - ### equals

    public boolean equals(Object another)
    This instance is equal to all instances of `VulkanCommandBufferCreateInfo` that have equal attribute values.
    Overrides:
      `equals` in class `Object`
    Returns:
      `true` if `this` is equal to `another` instance

  - ### hashCode

    public int hashCode()
    Computes a hash code from attributes: `pool`, `level`, `count`.
    Overrides:
      `hashCode` in class `Object`
    Returns:
      hashCode value

  - ### toString

    public String toString()
    Prints the immutable value `VulkanCommandBufferCreateInfo` with attribute values.
    Overrides:
      `toString` in class `Object`
    Returns:
      A string representation of the value

  - ### copyOf

    public static VulkanCommandBufferCreateInfo copyOf(VulkanCommandBufferCreateInfoType instance)
    Creates an immutable copy of a `VulkanCommandBufferCreateInfoType` value. Uses accessors to get values to initialize the new immutable instance. If an instance is already immutable, it is returned as is.
    Parameters:
      `instance` - The instance to copy
    Returns:
      A copied immutable VulkanCommandBufferCreateInfo instance

  - ### builder

    public static VulkanCommandBufferCreateInfo.Builder builder()
    Creates a builder for `VulkanCommandBufferCreateInfo`.

        VulkanCommandBufferCreateInfo.builder()
           .setPool(com.io7m.jcoronado.api.VulkanCommandPoolType) // required pool
           .setLevel(com.io7m.jcoronado.api.VulkanCommandBufferLevel) // optional level
           .setCount(int) // optional count
           .build();

    Returns:
      A new VulkanCommandBufferCreateInfo builder